<template>
    <v-navigation-drawer
        ref="sidebarRef"
        :clipped="true"
        :width="value ? drawer.width : undefined"
        :value="value"
        @input="$emit('input', value)"
        app
        absolute
        class="mn-main-sidebar"
    >
        <app-storage-switch />
        <main-sidebar-buttons />
        <app-tree-view />
    </v-navigation-drawer>
</template>

<script lang="ts">
import { defineComponent, nextTick, onMounted, Ref, ref, watch } from "@vue/composition-api";
import Vue from "vue";
import AppTreeView from "@/components/AppTreeView.vue";
import NodeButton from "@/components/ViewTree/NodeButton.vue";
import ContentEditable from "@/components/ContentEditable.vue";
import NodeLabel from "@/components/ViewTree/NodeLabel.vue";
import AppStorageSwitch from "@/components/AppStorageSwitch.vue";
import MainSidebarButtons from "@/components/MainSidebarButtons.vue";

export default defineComponent({
    components: {MainSidebarButtons, AppTreeView, NodeButton, ContentEditable, NodeLabel, AppStorageSwitch },
    name: "MainSidebar",
    setup(props) {
        const sidebarRef: Ref<Vue | undefined> = ref();
        const drawer: Ref<Record<string, unknown>> = ref({
            width: 550,
            borderSize: 3
        });
        let isDragging = false;

        /**
         * Makes the sidebar resizable by dragging its border.
         */
        const makeResizable = () => {
            let borderHoverTimeout: NodeJS.Timeout;
            const justStoppedDragging: { value: boolean } = { value: false };
            const borderIsDraggable: { value: boolean } = { value: false };

            const drawerElement = sidebarRef.value && sidebarRef.value.$el as HTMLElement;
            const borderElement = drawerElement && drawerElement.querySelector('.v-navigation-drawer__border') as HTMLElement;
            const headerElement = document.getElementById('omm-app-bar');
            const mainElement = document.getElementById('omm-main');

            if (!drawerElement || !borderElement || !headerElement || !mainElement) return;

            borderElement.draggable = false;

            const makeBorderNotDraggable = () => {
                clearTimeout(borderHoverTimeout);
                borderIsDraggable.value = false;
                borderElement.classList.remove('v-navigation-drawer__border--highlighted');
            }

            const makeBorderDraggable = () => {
                makeBorderNotDraggable()

                borderHoverTimeout = setTimeout(() => {
                    borderIsDraggable.value = true;
                    borderElement.classList.add('v-navigation-drawer__border--highlighted');
                }, 250);
            }

            /**
             * Performs the resizing by setting elements to current mouse position.
             * @param {MouseEvent} e
             */
            const resize = (e: MouseEvent) => {
                drawerElement.style.width = e.clientX + "px";
                headerElement.style.left = e.clientX + "px";
                mainElement.style.paddingLeft = e.clientX + "px";
            }

            /**
             * When stop dragging restore default elements values and styles.
             */
            const stopDragging = () => {
                isDragging = false;
                justStoppedDragging.value = true;
                setTimeout(() => justStoppedDragging.value = false, 200);

                const finalPosIntVal = parseInt(drawerElement.style.width.replace('px', ''));
                const finalPosition = finalPosIntVal < 10 ? '10px' : drawerElement.style.width;

                drawer.value.width = finalPosition;
                drawerElement.style.width = finalPosition;
                headerElement.style.left = finalPosition;
                mainElement.style.paddingLeft = finalPosition;

                drawerElement.style.transition = '';
                headerElement.style.transition = '';
                mainElement.style.transition = '';

                makeBorderNotDraggable();

                document.removeEventListener("mousemove", resize, false);
            }

            /**
             * Sets elements transition to initial and listen for mousemove event.
             */
            const startDragging = () => {
                isDragging = true;
                drawerElement.style.transition = 'initial';
                headerElement.style.transition = 'initial';
                mainElement.style.transition = 'initial';

                document.addEventListener("mousemove", resize, false);
            }

            document.addEventListener('mousedown', (e) => {
                if (e.target !== borderElement) return;
                if (isDragging === true) return;
                if (!borderIsDraggable.value) return;
                startDragging();
            }, false);

            document.addEventListener('mouseup', () => {
                if (isDragging === false) return;
                stopDragging();
            }, false);

            document.addEventListener('mouseleave', () => {
                if (isDragging === false) return;
                stopDragging();
            }, false);

            borderElement.addEventListener("mouseover", () => {
                if (isDragging) return;
                makeBorderDraggable();
            }, false);

            borderElement.addEventListener("mousemove", () => {
                if (isDragging) return;
                makeBorderDraggable();
            });

            borderElement.addEventListener("mouseleave", () => {
                if (isDragging) return;
                makeBorderNotDraggable();
            });

            watch(() => props.value,async (drawerIsVisible) => {
                await nextTick();

                if (drawerIsVisible) {
                    const drawerWidth = drawer.value.width as string;

                    drawerElement.style.width = drawerWidth;
                    headerElement.style.left = drawerWidth;
                    mainElement.style.paddingLeft = drawerWidth;
                } else {
                    headerElement.style.left = '0px';
                    mainElement.style.paddingLeft = '0px';
                }
            });
        }

        onMounted(() => {
            makeResizable();
        });

        return {
            drawer, sidebarRef
        };
    },
    props: { value: Boolean },
});
</script>

<style lang="scss" scoped>
.mn-main-sidebar {
    top: 0 !important;
    max-height: 100vh !important;
}


::v-deep {
    .v-navigation-drawer__border {
        width: 3px !important;
        cursor: col-resize;
        transition: initial;
        user-select: none;
        -webkit-user-drag: none;
    }
}

.theme--dark {
    ::v-deep {
        .v-navigation-drawer__border {
            background-color: var(--v-secondary-base) !important;

            &--highlighted {
                background-color: var(--v-primary-base) !important;
            }
        }
    }
}

.theme--light {
    ::v-deep {
        .v-navigation-drawer__border {
            background-color: var(--v-secondary-lighten5) !important;

            &--highlighted {
                background-color: var(--v-primary-base) !important;
            }
        }
    }
}


.v-treeview-node__content {
    .mn-treeview-label {
        cursor: pointer;
    }

    .mn-treeview-item-actions {
        display: none;
    }

    &:hover {
        .mn-treeview-item-actions {
            display: block;
        }
    }
}
</style>
